


class KAudioWorkletNode extends AudioWorkletNode
{
    constructor(context, callback , options) {
        super(context, 'kaudioprocess', options);       
        this.port.onmessage = this.onMessage.bind(this);
        this.callback = callback;
    }

    convert(n) {
        var v = n < 0 ? n * 32768 : n * 32767;       // convert in range [-32768, 32767]
        return Math.max(-32768, Math.min(32768, v)); // clamp
    }
    onMessage(e)
    {
        let i16array = new Int16Array(e.data.length)
        for(var i = 0 ; i < e.data.length ; i++)
        {  
            i16array[i] = this.convert(e.data[i])
        }
        this.callback(i16array.buffer);
    }

    stop()
    {
        this.port.postMessage('stop');
    }


}


class KAudioRecoder
{
  
    construct()
    {
        
    }
  

    startRecoder(onFeed = function(){})
    {
   

        navigator.getUserMedia = navigator.getUserMedia ||
        navigator.webkitGetUserMedia ||
        navigator.mozGetUserMedia;
        if (!navigator.getUserMedia) 
        {
            alert('浏览器不支持音频输入');
            return;
        }
        this.audioContext = new AudioContext({sampleRate:16000});
        const addModule = async () => {
            await this.audioContext.audioWorklet.addModule('common/kaudioprcess.js');
          }
        addModule();
        this.audioSource = null;
        this.audioProcessor = null;

        navigator.getUserMedia({ 
        audio: true,
        },function(stream){
            this.audioSource = this.audioContext.createMediaStreamSource(stream);        
            this.audioProcessor = new KAudioWorkletNode(this.audioContext,e=>{onFeed(e)});
            this.audioSource.connect(this.audioProcessor)
         //   this.audioProcessor.connect(this.audioContext.destination)

        }.bind(this),function(err){
            console.log(err)
        });


    }

    stopRecoder()
    {   
        if(this.audioProcessor != null)
        {
            this.audioProcessor.stop();
            this.audioSource.disconnect(this.audioProcessor)
            this.audioProcessor.disconnect(this.audioContext.destination)   
            this.audioContext = null;  
        }
    }

}



 
